FROM python:3-slim

# Install dependencies
RUN apt-get --yes --quiet --quiet update && \
    apt-get --yes --quiet --quiet install wget g++ && \
    rm -rf /var/lib/apt/lists/*

# Set Python to show logs as they occur
ENV PYTHONUNBUFFERED=0

# Download the gRPC health probe
RUN GRPC_HEALTH_PROBE_VERSION=v0.2.0 && \
    wget -qO/bin/grpc_health_probe https://github.com/grpc-ecosystem/grpc-health-probe/releases/download/${GRPC_HEALTH_PROBE_VERSION}/grpc_health_probe-linux-amd64 && \
    chmod +x /bin/grpc_health_probe

# Get generic Python packages
RUN python3 -m pip install --upgrade pip setuptools wheel pip-tools

# Set working directory
WORKDIR /var/teraflow

# Create module sub-folders
RUN mkdir -p /var/teraflow/opticalattackmitigator

# Get Python packages per module
COPY opticalattackmitigator/requirements.in opticalattackmitigator/requirements.in
RUN pip-compile --output-file=opticalattackmitigator/requirements.txt opticalattackmitigator/requirements.in
RUN python3 -m pip install -r opticalattackmitigator/requirements.txt

# Add files into working directory
COPY common/. common
COPY opticalattackmitigator/. opticalattackmitigator

# Start opticalattackmitigator service
ENTRYPOINT ["python", "-m", "opticalattackmitigator.service"]
